<!DOCTYPE html>
<html lang="en">
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0"/>
    <meta charset="utf-8"/>
    <title>API Documentation &raquo;\PhpOffice\PhpSpreadsheet\Shared\JAMA\QRDecomposition</title>
    <meta name="author" content=""/>
    <meta name="description" content=""/>        <link href="../css/template.css" rel="stylesheet" media="all"/>        <!--[if lt IE 9]>
        <script src="https://html5shim.googlecode.com/svn/trunk/html5.js" type="text/javascript"></script>
        <![endif]-->
        <script src="../js/jquery-1.7.1.min.js" type="text/javascript"></script>
        <script src="../js/jquery-ui-1.8.2.custom.min.js" type="text/javascript"></script>
        <script src="../js/jquery.mousewheel.min.js" type="text/javascript"></script>
        <script src="../js/bootstrap.js" type="text/javascript"></script>
        <script src="../js/template.js" type="text/javascript"></script>
        <script src="../js/prettify/prettify.min.js" type="text/javascript"></script>        <link rel="shortcut icon" href="../img/favicon.ico"/>
        <link rel="apple-touch-icon" href="../img/apple-touch-icon.png"/>
        <link rel="apple-touch-icon" sizes="72x72" href="../img/apple-touch-icon-72x72.png"/>
        <link rel="apple-touch-icon" sizes="114x114" href="../img/apple-touch-icon-114x114.png"/></head>
<body>    <div class="navbar navbar-fixed-top">
        <div class="navbar-inner">
            <div class="container">
                <a class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
                    <span class="icon-bar"></span> <span class="icon-bar"></span>
                    <span class="icon-bar"></span> </a>
                <a class="brand" href="../index.html">API Documentation</a>

                <div class="nav-collapse">
                    <ul class="nav">
                        <li class="dropdown">
                            <a href="#api" class="dropdown-toggle" data-toggle="dropdown">
                                API Documentation <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">                                    <li><a>Namespaces</a></li>                                    <li><a href="../namespaces/task_23.html">task_23</a></li>                                    <li><a href="../namespaces/task_18.html">task_18</a></li>                                    <li><a href="../namespaces/task_22.html">task_22</a></li>                                    <li><a href="../namespaces/Composer.html">Composer</a></li>                                    <li><a href="../namespaces/Matrix.html">Matrix</a></li>                                    <li><a href="../namespaces/Complex.html">Complex</a></li>                                    <li><a href="../namespaces/Psr.html">Psr</a></li>                                    <li><a href="../namespaces/PhpOffice.html">PhpOffice</a></li>                                    <li><a href="../namespaces/Samples.html">Samples</a></li>                                    <li><a href="../namespaces/task_21.html">task_21</a></li>                                    <li><a href="../namespaces/task_24.html">task_24</a></li>                                    <li><a href="../namespaces/task_20.html">task_20</a></li>                                    <li><a href="../namespaces/task_17.html">task_17</a></li>                                    <li><a href="../namespaces/task_19.html">task_19</a></li>                            </ul>
                        </li>
                        <li class="dropdown" id="charts-menu">
                            <a href="#charts" class="dropdown-toggle" data-toggle="dropdown">
                                Charts <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a href="../graph_class.html">
                                        <i class="icon-list-alt"></i>&#160;Class hierarchy diagram
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="dropdown" id="reports-menu">
                            <a href="#reports" class="dropdown-toggle" data-toggle="dropdown">
                                Reports <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a href="../errors.html">
                                        <i class="icon-list-alt"></i>&#160;Errors
                                    </a>
                                </li>
                                <li>
                                    <a href="../markers.html">
                                        <i class="icon-list-alt"></i>&#160;Markers
                                    </a>
                                </li>
                                <li>
                                    <a href="../deprecated.html">
                                        <i class="icon-list-alt"></i>&#160;Deprecated
                                    </a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
        <div class="go_to_top">
            <a href="#___" style="color: inherit">Back to top&#160;&#160;<i class="icon-upload icon-white"></i></a>
        </div>
    </div>
    <div id="___" class="container">
        <noscript>
            <div class="alert alert-warning">
                Javascript is disabled; several features are only available if Javascript is enabled.
            </div>
        </noscript>    <style>
        .deprecated h2 {
            text-decoration: line-through;
        }
    </style>
    <div class="row">
        <div class="span4">    <div class="btn-group view pull-right" data-toggle="buttons-radio">
        <button class="btn details" title="Show descriptions and method names"><i class="icon-list"></i></button>
        <button class="btn simple" title="Show only method names"><i class="icon-align-justify"></i></button>
    </div>
    <div class="btn-group visibility" data-toggle="buttons-checkbox">
        <button class="btn public active" title="Show public elements">Public</button>
        <button class="btn protected" title="Show protected elements">Protected</button>
        <button class="btn private" title="Show private elements">Private</button>
        <button class="btn inherited active" title="Show inherited elements">Inherited</button>
    </div>    <ul class="side-nav nav nav-list">
        <li class="nav-header">
            <i class="icon-custom icon-method"></i> Methods
            <ul>    <li class="methodpublic">
        <a href="#method___construct" title="__construct ::QR Decomposition computed by Householder reflections.">
            <span class="description">QR Decomposition computed by Householder reflections.</span><pre>__construct</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getH" title="getH ::Return the Householder vectors.">
            <span class="description">Return the Householder vectors.</span><pre>getH</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getQ" title="getQ ::Generate and return the (economy-sized) orthogonal factor.">
            <span class="description">Generate and return the (economy-sized) orthogonal factor.</span><pre>getQ</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getR" title="getR ::Return the upper triangular factor.">
            <span class="description">Return the upper triangular factor.</span><pre>getR</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_isFullRank" title="isFullRank ::Is the matrix full rank?">
            <span class="description">Is the matrix full rank?</span><pre>isFullRank</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_solve" title="solve ::Least squares solution of A*X = B.">
            <span class="description">Least squares solution of A*X = B.</span><pre>solve</pre>
        </a>
    </li>            </ul>
        </li>
        <li class="nav-header protected">» Protected
            <ul>            </ul>
        </li>
        <li class="nav-header private">» Private
            <ul>            </ul>
        </li>
        <li class="nav-header">
            <i class="icon-custom icon-constant"></i> Constants
            <ul>                <li class="constant">
                    <a href="#constant_MATRIX_RANK_EXCEPTION" title="MATRIX_RANK_EXCEPTION ::">
                        <span class="description"></span><pre>MATRIX_RANK_EXCEPTION</pre>
                    </a>
                </li>            </ul>
        </li>
    </ul>
        </div>

        <div class="span8">
            <div class="element class">
                <h1>QRDecomposition</h1>
                <small style="display: block; text-align: right">                </small>
                <p class="short_description">For an m-by-n matrix A with m &gt;= n, the QR decomposition is an m-by-n
   orthogonal matrix Q and an n-by-n upper triangular matrix R so that
   A = Q*R.</p>
                <div class="details">
                    <div class="long_description"><p>The QR decompostion always exists, even if the matrix does not have
full rank, so the constructor will never fail.  The primary use of the
QR decomposition is in the least squares solution of nonsquare systems
of simultaneous linear equations.  This will fail if isFullRank()
returns false.</p>
                    </div>
                    <table class="table table-bordered">                                <tr>
                                    <th>author                                    </th>
                                    <td><p>Paul Meagher</p>
<p>@version 1.1</p>
                                    </td>
                                </tr>                                <tr>
                                    <th>package                                    </th>
                                    <td><p>Default</p>
                                    </td>
                                </tr>                    </table>

                    <h3><i class="icon-custom icon-method"></i> Methods</h3>                        <a id="method___construct"></a>
                        <div class="element clickable methodpublic method___construct" data-toggle="collapse" data-target=".method___construct .collapse">
                            <h2>QR Decomposition computed by Householder reflections.</h2>
                            <pre>__construct(\PhpOffice\PhpSpreadsheet\Shared\JAMA\matrix $A)</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$A</h4>
                                                <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\matrix</code><p><p>Rectangular matrix</p></p>
                                            </div>                                </div>
                            </div>

                        </div>                        <a id="method_getH"></a>
                        <div class="element clickable methodpublic method_getH" data-toggle="collapse" data-target=".method_getH .collapse">
                            <h2>Return the Householder vectors.</h2>
                            <pre>getH(): \PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>Lower trapezoidal matrix whose columns define the reflections</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getQ"></a>
                        <div class="element clickable methodpublic method_getQ" data-toggle="collapse" data-target=".method_getQ .collapse">
                            <h2>Generate and return the (economy-sized) orthogonal factor.</h2>
                            <pre>getQ(): \PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>orthogonal factor</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getR"></a>
                        <div class="element clickable methodpublic method_getR" data-toggle="collapse" data-target=".method_getR .collapse">
                            <h2>Return the upper triangular factor.</h2>
                            <pre>getR(): \PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>upper triangular factor</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_isFullRank"></a>
                        <div class="element clickable methodpublic method_isFullRank" data-toggle="collapse" data-target=".method_isFullRank .collapse">
                            <h2>Is the matrix full rank?</h2>
                            <pre>isFullRank(): boolean</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>boolean</code><p><p>true if R, and hence A, has full rank, else false</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_solve"></a>
                        <div class="element clickable methodpublic method_solve" data-toggle="collapse" data-target=".method_solve .collapse">
                            <h2>Least squares solution of A*X = B.</h2>
                            <pre>solve(\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix $B): \PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$B</h4>
                                                <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>a Matrix with as many rows as A and any number of columns</p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>matrix that minimizes the two norm of Q<em>R</em>X-B</p></p>                                </div>
                            </div>

                        </div>                        <h3><i class="icon-custom icon-constant"></i> Constants</h3>                            <a id="constant_MATRIX_RANK_EXCEPTION"> </a>
                            <div class="element clickable constant constant_MATRIX_RANK_EXCEPTION" data-toggle="collapse" data-target=".constant_MATRIX_RANK_EXCEPTION .collapse">
                                <h2>MATRIX_RANK_EXCEPTION</h2>
                                <pre>MATRIX_RANK_EXCEPTION</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>
                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>
                                    </div>
                                </div>
                            </div>                        <h3><i class="icon-custom icon-property"></i> Properties</h3>                            <a id="property_QR"> </a>
                            <div class="element clickable propertyprivate property_QR" data-toggle="collapse" data-target=".property_QR .collapse">
                                <h2>Array for internal storage of decomposition.</h2>
                                <pre>QR :array</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>array</code>                                    </div>
                                </div>
                            </div>                            <a id="property_m"> </a>
                            <div class="element clickable propertyprivate property_m" data-toggle="collapse" data-target=".property_m .collapse">
                                <h2>Row dimension.</h2>
                                <pre>m :integer</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>integer</code>                                    </div>
                                </div>
                            </div>                            <a id="property_n"> </a>
                            <div class="element clickable propertyprivate property_n" data-toggle="collapse" data-target=".property_n .collapse">
                                <h2>Column dimension.</h2>
                                <pre>n :integer</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>integer</code>                                    </div>
                                </div>
                            </div>                            <a id="property_Rdiag"> </a>
                            <div class="element clickable propertyprivate property_Rdiag" data-toggle="collapse" data-target=".property_Rdiag .collapse">
                                <h2>Array for internal storage of diagonal of R.</h2>
                                <pre>Rdiag :array</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>array</code>                                    </div>
                                </div>
                            </div>                </div>
            </div>
            <a id="\PhpOffice\PhpSpreadsheet\Shared\JAMA\QRDecomposition"></a>
            <ul class="breadcrumb">
                <li><a href="../index.html"><i class="icon-custom icon-class"></i></a></li>
    <li><span class="divider">\</span><a href="../namespaces/PhpOffice.PhpSpreadsheet.Shared.JAMA.html">JAMA</a></li>
                <li class="active"><span class="divider">\</span><a href="../classes/PhpOffice.PhpSpreadsheet.Shared.JAMA.QRDecomposition.html">QRDecomposition</a></li>
            </ul>
        </div>
    </div>    </div>    <footer class="span12">
            Template is built using <a href="http://twitter.github.com/bootstrap/">Twitter Bootstrap 2</a> and icons provided by
            <a href="http://glyphicons.com/">Glyphicons</a>.<br/>
            Documentation is powered by <a href="http://www.phpdoc.org/">phpDocumentor</a> and<br/>
            generated onFri, 14 Feb 2020 19:36:49 +0000.<br/>
    </footer></body>
</html>
